(function() {
    'use strict';
$( document ).ready(function() {
	aj_setup();
});

function aj_setup(){
    console.log("Algolia Implementation for buyzero.de v0.9.3 - exotic FireDiamond. Hello, Nancy!");

	//attach a special element before
	//#megamenu-header-menu2
	//in #megamenu_2
	//display: block; 
	var ajr_na = '<div id="ajr_na" style="display: none;">' +
				'<div id="ajr_na_menuHeading">' +
					'<div class="megamenuToogle-wrapper">' +
						'<div class="megamenuToogle-pattern">' +
							'<div class="container">' +
								'<a href="#" style="color:white" id="ajr_na_rpicollapsed">Raspberry Pi Shop ▲</a>' +
							'</div>' +
						'</div>' +
					'</div>' +
				'</div>' +
			'</div>';
	$("#megamenu_2").prepend(ajr_na);
	$("#ajr_na_rpicollapsed").on('click',ajr_na_escape);
	
	//attach a new DOM element to put the search into
	//later on this can be done using the website itself...
	/*
		https://www.algolia.com/doc/tutorials/search-ui/instant-search/build-an-instant-search-results-page/instantsearchjs/
		aj-search-results = hits
		aj-search-pagination = pagination
		
		already included in Shopify:
		<script src="//cdn.jsdelivr.net/instantsearch.js/1/instantsearch.min.js" type="text/javascript"></script>
	*/
	$(".main-content").before('<div id="aj-search-container" class="aj-main-content full-width"><div class="background"><div class="pattern"><div class="container"><div class="row"><div class="col-md-12"><div class="row"><div class="col-md-12 center-column content-without-background">'+
							"<DIV style='display:block;'>"+
							  "<H1>Suchresultate für: <span id='sc-query'></span></H1>" +
							  "<DIV id='aj-right-container'>" +
								"<DIV id='aj-clear-all'></DIV>" +
								"<DIV id='aj-facet-brand'></DIV>" +
								"<DIV id='aj-facet-category'></DIV>" +
								"<DIV id='aj-facet-price'></DIV>" +
							  "</DIV>" +
							  "<DIV id='aj-left-container'>" +
								  "<DIV id='aj-stats'></DIV>" +
								  "<DIV id='aj-search-results'></DIV>" +
								  "<DIV id='aj-search-pagination'></DIV>" +
							  "</DIV" +
						  "</DIV>" +
						  '</div></div></div></div></div></div></div></div>'
						  );
	
	
	$(".main-content").before(''+
	  '<script type="text/html" id="aj-hit-template">'+
'		  <div class="aj-hit">'+
'			<div class="aj-hit-image">'+
'			  <A HREF="{{product_link}}"><img src="{{image}}" alt="{{title}}"></A>'+
'			</div>'+
'			<div class="aj-hit-content">'+
'			  <div class="aj-hit-title"><A HREF="{{product_link}}">{{{_highlightResult.title.value}}}{{variant_title}}</A></div>'+
			  '<p class="aj-hit-description">{{{_highlightResult.body_html_safe.value}}} &nbsp; <A HREF="{{product_link}}">&raquo;&nbsp;mehr</A></p>'+
			  '<p class="aj-hit-sku"><A HREF="{{product_link}}">{{sku}}</A></p>'+
'			  <div class="aj-hit-bottominfos">' +
'				<div class="aj-hit-price">{{price}} €</div>' +
'				<div class="aj-hit-stock">{{inventory_quantity}} auf Lager </div>'+
'				<div  class="aj-hit-link"><A HREF="{{product_link}}">zur Produktseite</A></div>'+
'			 </div>'+
		    '</div>'+
			'<HR class="aj-divider">' +
		  '</div>'+
		'</script>'+
	'');
	
	var pb = aj_setup_search();
	//#search_query is the input we want
	$("#search_query").keyup(function(search) {
	  updateSearch(pb);
	});	
}
	
function display_always_hack(){
	$("#search_query").val("Unicorn");
	updateSearch();
}
	
function aj_setup_search(){
	var point_both = {};
	
	var search = instantsearch({
	  appId: '6EW3LZZXKR',
	  apiKey: '2be7947193c04197370ae52536f61a36', // search only API key, no ADMIN key
	  indexName: 'shopify_buyzero_de_products',
	  urlSync: true,
	  searchParameters: {
		hitsPerPage: 10
	  },
	  searchFunction(my_helper){
		  point_both.ihelper = my_helper;
		  //search.helper.setQuery('Pi 3'); //sic!
		  //helper.search(); //sic!
		  
		  if(my_helper.state.query === '') {	
				return;
			}
		  my_helper.search();
	  } //end searchFunction
	});//end instantsearch setup

	search.addWidget(
	  instantsearch.widgets.hits({
		container: '#aj-search-results',
		templates: {
		  item: document.getElementById('aj-hit-template').innerHTML,
		  empty: "Es konnten leider keine Resultate für die Suchanfrage <em>\"{{query}}\"</em> gefunden werden."
		},
		transformData: {
			item: function (my_result) {
			//console.log(my_result);
			//console.log(my_result._highlightResult.body_html_safe.value);
			if (my_result["variant_title"] == 'Default Title'){
				my_result["variant_title"] = '';
			}
			else
			{
				my_result["variant_title"] = ' :: ' + my_result["variant_title"];
			}
			//my_result["body_html_safe"] = my_result["body_html_safe"].substring(0,175) + '…';
			//we do NOT want multiline, we want to match the REAL ending of the string. /m would match at the line ending ..
			var pattern_a = /(.*?)(<[^>]*)?$/i;
			var pattern_b = /<em>[^<]+$/i;
			
			//take the first matched group - which excludes the second match.
			var body_string = my_result._highlightResult.body_html_safe.value.substring(0,175).replace(pattern_a,"$1");
			
			if (pattern_b.test(body_string)){
				body_string = body_string + "</em>"
			}
			//search for pi 3 b+
			//product id https://buyzero.de/products/budget-kit-raspberry-pi-3-model-b?variant=698066665499
			my_result._highlightResult.body_html_safe.value = body_string + '…';
			
			my_result["product_link"] = "https://buyzero.de/products/" + my_result["handle"] + "?variant=" + my_result["id"];
			return my_result;
			}
		}
	  })
	);
	

	
	// Add this after the other search.addWidget() calls
	search.addWidget(
	  instantsearch.widgets.pagination({
		container: '#aj-search-pagination',
		render: function(my_obj){
			console.log("render");
			console.log(my_obj);
		},
		getConfiguration: function(my_obj){
			console.log("getConfiguration");
			console.log(my_obj);
		}
	  })
	);
	

	// Faceting
	search.addWidget(
	  instantsearch.widgets.refinementList({
		container: '#aj-facet-brand',
		attributeName: 'vendor',
		operator: 'or',
		limit: 5,
		showMore: true,
		cssClasses: {
			header: 'aj-refine-header',
			count: 'aj-refine-count'
		},
		templates: {
		  header: 'Marke / Brand'
		}
	  })
	);
	
	search.addWidget(
	  instantsearch.widgets.refinementList({
		container: '#aj-facet-category',
		attributeName: 'product_type',
		operator: 'or',
		limit: 5,
		showMore: true,
		cssClasses: {
			header: 'aj-refine-header',
			count: 'aj-refine-count'
		},
		templates: {
		  header: 'Produkttyp'
		}
	  })
	);

	/*search.addWidget(
	  instantsearch.widgets.priceRanges({
		container: '#aj-facet-price',
		attributeName: 'price',
		cssClasses: {
			header: 'aj-refine-header',
		},
		labels: {
		  currency: '€',
		  separator: 'bis',
		  button: 'Anwenden'
		},
		templates: {
		  header: 'Preisfilter'
		}
	  })
	);*/
	search.addWidget(
	  instantsearch.widgets.rangeSlider({
		container: '#aj-facet-price',
		attributeName: 'price',
		cssClasses: {
			header: 'aj-refine-header',
		},
		templates: {
		  header: 'Preisfilter'
		},
		tooltips: {
		  format: function(rawValue) {
			return Math.round(rawValue).toLocaleString() + '&nbsp;€';
		  }
		}
	  })
	);
	
	search.addWidget(
	  instantsearch.widgets.clearAll({
		container: '#aj-clear-all',
		templates: {
		  link: 'Filter zurücksetzen / Reset'
		},
		autoHideContainer: false,
		clearsQuery: true,
	  })
	);
	
	search.addWidget(
	  instantsearch.widgets.stats({
		container: '#aj-stats'
	  })
	);
	
	search.start();
	point_both.search = search;
	return point_both;
}
	
function ajr_na_escape() {
	//remove the current search
	$("#search_query").val("");
	updateSearch();
}
	
function updateSearch(pb){
	var my_query = $("#search_query").val();
	//$(".main-content").html(my_query);
	if (my_query) {
		$(".main-content").hide();
		$("#megamenu-header-menu2").hide();
		$("#ajr_na").show();
		$("#sc-query").html(my_query);
		$("#aj-search-container").show();
		pb.search.helper.setQuery(my_query);
		//console.log(search_handle.helper.state);
		pb.ihelper.search();
	}
	else {
		$("#aj-search-container").hide();
		$(".main-content").show();
		$("#ajr_na").hide();
		$("#megamenu-header-menu2").show();
	}

}



})();